> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-transactions/network/fetchfeeestimate.md).

# fetchFeeEstimate

Estimates the transaction fee by trying `fetchFeeEstimateTransaction` first and falling back to `fetchFeeEstimateTransfer` if the node cannot provide an estimate (e.g. for a new contract call it has not seen before).

***

### Usage

```ts
import {
  makeUnsignedSTXTokenTransfer,
  fetchFeeEstimate,
} from '@stacks/transactions';

const transaction = await makeUnsignedSTXTokenTransfer({
  recipient: 'ST1SJ3DTE5DN7X54YDH5D64R3BCB6A2AG2ZQ8YPD5',
  amount: 1000000n,
  publicKey: '034f355bdcb7cc0af728ef3cceb9615d90684bb5b2ca5f859ab0f0b704075871aa',
  network: 'testnet',
  fee: 0, // placeholder — we'll estimate
  nonce: 0n,
});

const estimatedFee = await fetchFeeEstimate({
  transaction,
  network: 'testnet',
});
transaction.setFee(estimatedFee);
```

#### Notes

* The builder functions call this automatically when `fee` is not provided.
* Returns the middle (median) estimation from the three-tier response.

[**Reference Link**](https://github.com/stx-labs/stacks.js/tree/main/packages/transactions/src/fetch.ts#L228)

***

### Signature

```ts
function fetchFeeEstimate(opts: {
  transaction: StacksTransactionWire;
} & NetworkClientParam): Promise<bigint | number>;
```

***

### Returns

`Promise<bigint | number>`

A promise that resolves to the estimated fee in microSTX.

***

### Parameters

#### opts.transaction (required)

* **Type**: `StacksTransactionWire`

The transaction to estimate fees for.

#### opts.network (optional)

* **Type**: `StacksNetworkName | StacksNetwork`

The network to query. Inferred from the transaction if not provided.

#### opts.client (optional)

* **Type**: `NetworkClient`

Custom client configuration for the API call.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-transactions/network/fetchfeeestimate.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
